
//Description: Debouncing function for one Pin conected to an external switch
//Target Device : ATmega8

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <inttypes.h>
#include <stdlib.h>
#include "interrupt.h"

volatile uint8_t pin;
volatile uint8_t *port;
	

volatile uint8_t anzahl_overflows= 0;
volatile uint8_t wait = 1;
volatile unsigned char actualvalue = 1;
volatile unsigned char lastvalue = 1;
volatile unsigned char firstcall = 0;


int debounce_pin(volatile uint8_t *port, uint8_t pin)
{
	
	TIMSK = (1 << TOIE0);					//Timer/counter 0 interrupt enable
	TCCR0 = (1 << CS00) | (1 << CS02);
	
	while (wait)
	{
	
	}
	
	return wait;
}


ISR(TIMER0_OVF_vect)		//16,4ms vorber
{
	PORTB = ++anzahl_overflows;
	
	lastvalue = actualvalue;
	actualvalue = *port & (1 << pin);
	
	if (firstcall == 1)
	{
		if (lastvalue == actualvalue)
		{
			wait = 0;
			return;
		}
	}
		
	if (lastvalue != actualvalue)
	{
		firstcall = 1;
	}
}

int main(void)
{
	DDRB = 0xFF;				//LED port
	PORTB = 0xFF;				//LEDs aus
	DDRC &=  ~(1<<PC0);		//PC0 ist Eingang
	PORTC |= (1<<PC0); 		//Pullup ist aktiv
	sei();
	
	port = &PINC;				//WARUM DARF DIESE ZEILE NICHT GANZ OBEN STEHEN UNTER DER DEKLARATION DES GLOBALEN POINTERS?
	debounce_pin(&PINC, pin); 	//bergibt Adresse von PORT und den pin
	
	PORTB = 0x00;				//Taste stabil, alle LEDs leuchten
	cli();
	
	
}
	

